#
# symmetry operators in x,y,z of conventional cell.
# 
# For the case of non-trivial centerings,
# specify only (0,0,0)+ set to generate the operators for the primitive cell.
#

function val = symopr(x,y,z)
  val = [
  x,y,z    
  -x,-y,z  
  -x,y,-z  
  x,-y,-z  
  z,x,y    
  z,-x,-y  
  -z,-x,y  
  -z,x,-y  
  y,z,x    
  -y,z,-x  
  y,-z,-x  
  -y,-z,x  
  y,x,-z   
  -y,-x,-z 
  y,-x,z   
  -y,x,z   
  x,z,-y   
  -x,z,y   
  -x,-z,-y 
  x,-z,y   
  z,y,-x   
  z,-y,x   
  -z,y,x   
  -z,-y,-x 
  -x,-y,-z 
  x,y,-z   
  x,-y,z   
  -x,y,z   
  -z,-x,-y 
  -z,x,y   
  z,x,-y   
  z,-x,y   
  -y,-z,-x 
  y,-z,x   
  -y,z,x   
  y,z,-x   
  -y,-x,z  
  y,x,z    
  -y,x,-z  
  y,-x,-z  
  -x,-z,y  
  x,-z,-y  
  x,z,y    
  -x,z,-y  
  -z,-y,x  
  -z,y,-x  
  z,-y,-x  
  z,y,x    
]';
endfunction

#
# form of the primitive cell in unit vectors of the conventional cell.
#
aa = [0.5,0.5,0.0; 0.5,0.0,0.5; 0.0,0.5,0.5]';


x = 0;
y = 0;
z = 0;
s0 = symopr(x,y,z);

x = 1;
y = 0;
z = 0;
s1 = symopr(x,y,z);
s1 = s1 - s0; 

x = 0;
y = 1;
z = 0;
s2 = symopr(x,y,z);
s2 = s2 = s2 - s0; 

x = 0;
y = 0;
z = 1;
s3 = symopr(x,y,z);
s3 = s3 - s0; 

sym = ones(size(s0)(2),12);
for i=1:size(s0)(2)
  op = [s1(:,i),s2(:,i),s3(:,i)];
  t = int32(inv(aa)*op*aa);
  tt = mod(inv(aa)*s0(1:3,i), 1.0);
  # 
  # convert to reciprocal space operator
  #
  r = inv(t)';
  sym(i,:) = [r(1:3,1)',r(1:3,2)',r(1:3,3)',tt'];
end
sym

# Local Variables: ***
# mode:fundamental ***
# End: ***
