/*
  Copyright (c) 2012-2013 Yoshihide Yoshimoto
 */

#ifndef XTAPP_EXCHANGE_KERN_CUDA
#define XTAPP_EXCHANGE_KERN_CUDA

typedef struct {double re; double im;} double_complex;

#ifdef __cplusplus
extern "C"
#endif
void init_exchange_(int *ifgami, int *niwi, int *njwi, int* nwxi, int *nwyi, int *nwzi);

#ifdef __cplusplus
extern "C"
#endif
void get_exchange_nlxyz_(int *nlxo, int *nlyo, int *nlzo);

#ifdef __cplusplus
extern "C"
#endif
void setup_exchange_clkern_(const int *nkmesh, const double bb[3][3], const double q[3], const double *rcp, const double *rdp);

#ifdef __cplusplus
extern "C"
#endif
void setup_exchange_clkerns_(const int *nkmesh, const double bb[3][3], const double q[3], const double *rcp, const double *rdp);

#ifdef __cplusplus
extern "C"
#endif
void teardown_exchange_();

#ifdef __cplusplus
extern "C"
#endif
void compute_exchange_(int *miwi, int *mjwi, double_complex *wfi, double_complex *wfj, double_complex *vxp, double *wgt);

#ifdef __cplusplus
extern "C"
#endif
void compute_excheng_(int *miwi, int *mjwi, double_complex *wfi_in, double_complex *wfj_in, double *exeng, double *exengs, double *wgti, double *wgtj);

#endif
