!
! Copyright (c) 1983-2000 TAPP Consortium
! Copyright (c) 2000-2013 Yoshihide Yoshimoto
!
module ioqg
  implicit none
  integer,private:: nkc,nkd
  integer,private,allocatable:: nob(:)
  type,private:: qg4atm
     complex(kind=8),pointer:: qga(:,:)
  end type qg4atm
  type(qg4atm),allocatable,private:: storage(:)
contains
  subroutine openqg(inkc,inkd)
    implicit none
    integer,intent(in):: inkc, inkd
    !
    integer:: ikd,err
    !
    nkc=inkc
    nkd=inkd
    allocate(nob(nkd),stat=err)
    allocate(storage(nkd),stat=err)
    call chkalloc('openqg','storage',err)
    return
  end subroutine openqg

  subroutine closeqg()
    implicit none
    integer:: ikd
    !
    do ikd=1,nkd
       deallocate(storage(ikd)%qga)
    end do
    deallocate(storage)
    !
    return
  end subroutine closeqg

  subroutine newqg(ikd, inob, qg)
    implicit none
    integer,intent(in):: ikd, inob
    !
    complex(kind=8),pointer:: qg(:,:)

    integer:: err

    nob(ikd) = inob
    allocate(storage(ikd)%qga(nkc,(nob(ikd)*(nob(ikd)+1))/2),stat=err)
    call chkalloc('openqg','storage',err)
    !
    qg => storage(ikd)%qga
    return
  end subroutine newqg

  subroutine getqg(ikd, qg)
    implicit none
    integer,intent(in):: ikd
    !
    complex(kind=8),pointer:: qg(:,:)
    !
    qg => storage(ikd)%qga
    return
  end subroutine getqg

  subroutine putqg(ikd, qg)
    implicit none
    integer,intent(in):: ikd
    !
    complex(kind=8),pointer:: qg(:,:)
    !
    nullify(qg)
    return
  end subroutine putqg

  subroutine relqg(ikd, qg)
    implicit none
    integer,intent(in):: ikd
    !
    complex(kind=8),pointer:: qg(:,:)
    !
    nullify(qg)
    return
  end subroutine relqg
end module ioqg
