!
! Copyright (c) 1983-2000 TAPP Consortium
! Copyright (c) 2000-2013 Yoshihide Yoshimoto
!
function smpln(f,x,n)
  implicit none
  integer n
  real*8 f, x
  dimension f(n),x(n)
  real*8 smpln
  real*8 sa, sb, h, temp
  integer nnn, i
  !
  if ((x(1).le.0.0d0).or.(x(1)*x(n).le.0.0d0)) then
     write(6,*)' ERROR  N,X(1),X(N)',n,x(1),x(n)
     stop 'SMPLN'
  end if
  h=log(x(n)/x(1))/dble(n-1)
  temp=x(1)*exp(h)
  if (abs(x(2)-temp).gt.1.d-12) then
     write(6,*)' X(1),X(2),H,EXP(H)=',x(1),x(2),h,exp(h)
     stop 'SMPLN'
  end if
  sa=0.0d0
  sb=0.0d0
  do i=3,n-2,2
     sa=sa+f(i-1)*x(i-1)
     sb=sb+f(i)*x(i)
  end do
  nnn=mod(n,2)
  if (nnn.eq.1) then
     sa=sa+f(n-1)*x(n-1)
     smpln=(f(1)*x(1)+4.0d0*sa+2.0d0*sb+f(n)*x(n))/3.0d0*h
  else if (n.ge.6) then
     sa=sa+f(n-2)*x(n-2)
     smpln=((f(1)*x(1)+4.0d0*sa+2.0d0*sb)/3.0d0 &
             +(f(n-3)*x(n-3)-5.d0*f(n-2)*x(n-2))/24.d0 &
             +(9.d0*f(n-1)*x(n-1)+3.d0*f(n)*x(n))/8.d0)*h
  else
     write(6,*)'ERROR IN SMPSN     N=',n
     stop
  end if
  return
end function smpln

integer function lmrtoi(n, rad, z, g)
  implicit none
  integer,intent(in):: n
  real(kind=8),intent(in):: rad(n)
  real(kind=8),intent(in):: z, g

  real(kind=8):: zog
  integer:: i

  if (g .eq. 0.0d0) then
     lmrtoi = n
     return
  end if
  zog = z/g
  if (zog .le. rad(1)) then
     lmrtoi = 0
     return
  else if (zog .ge. rad(n)) then
     lmrtoi = n
     return
  end if
  i = (n-1)*((log(zog) - log(rad(1)))/(log(rad(n)) - log(rad(1)))) + 1
  if ((rad(i) .lt. zog)  .and. (zog .lt. rad(i+1))) then
     lmrtoi = i
     return
  else if (rad(i) .eq. zog) then
     lmrtoi = i - 1
     return
  else
     write(6,*) 'Error: lmrtoi'
     write(6,*) 'i, rad(i), zog', i, rad(i), zog
     stop
  end if
end function lmrtoi
