!
! Copyright (c) 2013,2015-2017 Yoshihide Yoshimoto
!
program xticonv
  use util
  use subr_inputparam
  use subr_inputsym
  use subr_inputatom
  use subr_inputkpoints
  use subr_inputstropt
  use subr_rddata_nompi
  use subr_fmtconv
  implicit none
#include "config90.h"
  real(kind=8):: ax,bx,va,vb,qf,qm,qc,znext,dspin
  real(kind=8):: qbtp(3)
  real(kind=8):: ekbt
  integer:: ng,nsv,nnp,nkd,nsi,ncomp,nspin,ndens
  integer:: nw,ismode
  integer:: iopt(nopt)
  integer:: niter0,niter1
  integer:: mssg
  integer,parameter:: nf = 10
  !
  real(kind=8):: aa(3,3),bb(3,3)
  integer:: rg(3,3,nsymq),pg(3,nsymq),srg(nsymq)
  integer,pointer:: kd(:)
  real(kind=8),pointer:: asi(:,:)

  integer:: info

  real(kind=8):: eps,eeps,beta,qexat(2)
  integer:: ndiag0,ndiag1,itsb
  real(kind=8):: uptime
  real(kind=8):: qbsp
  integer:: nbsf
  real(kind=8):: fwqcom
  integer:: xctp
  real(kind=8):: thr_hybrid, thr_noncol, spaxs(3)
  integer:: osqnrm
  integer:: axetp
  real(kind=8):: qprcnd(6)
  real(kind=8),pointer:: zoin(:),znin(:)

  character(len=256):: cbuf
  integer:: ios,ftype

  info = 0
  mssg = -1

  call getarg(1, cbuf)

  if (trim(cbuf).eq.'cif') then
     ftype = 1
  else if (trim(cbuf).eq.'xyz') then
     ftype = 2
  else if (trim(cbuf).eq.'xyzpr') then
     ftype = 3
  else if (trim(cbuf).eq.'xyzmol') then
     ftype = 4
  else if (trim(cbuf).eq.'poscar') then
     ftype = 5
  else
     write(6,*) 'usage: xticonv (cif|xyz|xyzpr|xyzmol|poscar) fname'
     stop
  end if

  call getarg(2, cbuf)
  open(nf, file=cbuf, status='old', action='read', iostat=ios)
  if (ios.ne.0) then
     write(6,*) 'error in opening '//trim(cbuf)
     stop
  end if

  ! namelist input

  call seektomagic(nf,magic_inputparam,mssg,info)
  call read_tappinput(nf,ax,aa,ncomp,nspin,ndens,ismode,qf,qm,qc,beta, &
       qbtp,nkd,nsi,nw,znext,dspin,nopt,iopt,eps,eeps,ekbt, &
       uptime,niter0,niter1,itsb,ndiag0,ndiag1, &
       qbsp,nbsf,fwqcom,xctp,qexat,thr_hybrid,osqnrm,axetp,qprcnd, &
       thr_noncol,spaxs,mssg,info)

  call seektomagic(nf,magic_tappsym,mssg,info)
  call read_tappsym(nf,ng,nsv,nnp,rg,pg,srg,nsymq,mssg,info)

  call seektomagic(nf,magic_tappatom,mssg,info)
  call read_tappatom(nf,nkd,zoin,znin,nsi,kd,asi,mssg,info)

  if (info.ne.0) then
     write(6,*) 'input error'
     stop
  end if

  call latgen(ax,bx,aa,bb,va,vb)

  cbuf = 'xTAPP_input: ' // cbuf
  
  if (ftype.eq.1) then
     call printcif(cbuf,aa,nkd,zoin,znin,nsi,kd,asi)
  else if (ftype.eq.2) then
     call printxyz(cbuf,aa,nkd,zoin,znin,nsi,kd,asi)
  else if (ftype.eq.3) then
     call printxyzpr(cbuf,aa,nkd,zoin,znin,nsi,kd,asi)
  else if (ftype.eq.4) then
     call printxyzmol(cbuf,aa,nkd,zoin,znin,nsi,kd,asi)
  else if (ftype.eq.5) then
     call printposcar(6,ax,aa,nkd,zoin,znin,nsi,kd,asi)
  end if

  stop
end program xticonv
