!
! Copyright (c) 2000-2013 Yoshihide Yoshimoto
!
program test
  use xcgga
  use pfft_3d
  implicit none
  integer,parameter:: nx = 100, ny = 100, nz = 100, nxyz = nx*ny*nz
  real(kind=8),parameter:: pi = 3.14159265358979323846d0

  real(kind=8):: rho(nx,ny,nz,2),rhop(nx,ny,nz,2)
  real(kind=8):: tmprho(nx,ny,nz,2),tmprhop(nx,ny,nz,2)
  real(kind=8):: tmprho2(nx,ny,nz),tmprhop2(nx,ny,nz)
  real(kind=8):: drho(nx,ny,nz,3,2),adrho(nx,ny,nz,2),laprho(nx,ny,nz,2)
  real(kind=8):: adrhot(nx,ny,nz),drhot(3),dadrho(3),delgr(nx,ny,nz,2),delgrt(nx,ny,nz)
  real(kind=8):: bb(3,3),va
  integer:: kf(3,nxyz),nkfxa
  real(kind=8):: x,y,z
  real(kind=8):: exc, exa,lcor, &
       lpot, exlsd,vxuplsd,vxdnlsd,eclsd,vcuplsd,vcdnlsd, &
       expw91,vxuppw91,vxdnpw91,ecpw91,vcuppw91,vcdnpw91, &
       expbe,vxuppbe,vxdnpbe,ecpbe,vcuppbe,vcdnpbe
  type (fft3_struct):: fs

  integer:: i,j,k,imax(3),ig
  real(kind=8):: delta,zeta

  do k=1,nz
     z = dble(k-1)/nz
     do j=1,ny
        y = dble(j-1)/ny
        do i=1,nx
           x = dble(i-1)/nx
           rho(i,j,k,1) = 0.05d0*(cos(2.0d0*pi*(x+y+z))+2.0)
           rho(i,j,k,2) = 0.05d0*(sin(2.0d0*pi*(x+y+z))+2.0)
           rhop(i,j,k,1) = 0.05d0*(cos(2.0d0*pi*(x+y+z))+2.0)
           rhop(i,j,k,2) = 0.05d0*(sin(2.0d0*pi*(x+y+z))+2.0)
           !rho(i,j,k,1) = 0.05d0*(cos(2.0d0*pi*(x+y+z))+2.0)
           !rho(i,j,k,2) = 0.05d0*(cos(2.0d0*pi*(x+y+z))+2.0)
           !rhop(i,j,k,1) = 0.05d0*(cos(2.0d0*pi*(x+y+z))+2.0)
           !rhop(i,j,k,2) = 0.05d0*(cos(2.0d0*pi*(x+y+z))+2.0)
           !if (abs(x) .lt. 0.50d0) then
           !   rho(i,j,k,1) = x+0.6d0
           !   rho(i,j,k,2) = x+0.6d0
           !   rhop(i,j,k,1) = x+0.6d0
           !   rhop(i,j,k,2) = x+0.6d0
           !else if (x .ge. 0.5d0) then
           !   rho(i,j,k,1) = -x+1.6d0
           !   rho(i,j,k,2) = -x+1.6d0
           !   rhop(i,j,k,1) = -x+1.6d0
           !   rhop(i,j,k,2) = -x+1.6d0
           !else
           !   rho(i,j,k,1) = -x-0.4d0
           !   rho(i,j,k,2) = -x-0.4d0
           !   rhop(i,j,k,1) = -x-0.4d0
           !   rhop(i,j,k,2) = -x-0.4d0
           !end if
        end do
     end do
  end do
  do k=2,nz-1
     do j=2,ny-1
        do i=2,nx-1
           drho(i,j,k,1,1) = (rho(i+1,j,k,1) - rho(i-1,j,k,1))/(2.0d0/nx)
           drho(i,j,k,2,1) = (rho(i,j+1,k,1) - rho(i,j-1,k,1))/(2.0d0/ny)
           drho(i,j,k,3,1) = (rho(i,j,k+1,1) - rho(i,j,k-1,1))/(2.0d0/nz)
           adrho(i,j,k,1) = sqrt(drho(i,j,k,1,1)*drho(i,j,k,1,1) + &
                drho(i,j,k,2,1)*drho(i,j,k,2,1) + &
                drho(i,j,k,3,1)*drho(i,j,k,3,1))
           laprho(i,j,k,1) = &
                (rho(i+1,j,k,1) + rho(i-1,j,k,1) - 2.0d0*rho(i,j,k,1)) &
                /(1.0d0/nx)/(1.0d0/nx) &
                + (rho(i,j+1,k,1) + rho(i,j-1,k,1) - 2.0d0*rho(i,j,k,1)) &
                /(1.0d0/ny)/(1.0d0/ny) &
                + (rho(i,j,k+1,1) + rho(i,j,k-1,1) - 2.0d0*rho(i,j,k,1)) &
                /(1.0d0/nz)/(1.0d0/nz)

           drho(i,j,k,1,2) = (rho(i+1,j,k,2) - rho(i-1,j,k,2))/(2.0d0/nx)
           drho(i,j,k,2,2) = (rho(i,j+1,k,2) - rho(i,j-1,k,2))/(2.0d0/ny)
           drho(i,j,k,3,2) = (rho(i,j,k+1,2) - rho(i,j,k-1,2))/(2.0d0/nz)
           adrho(i,j,k,2) = sqrt(drho(i,j,k,1,2)*drho(i,j,k,1,2) + &
                drho(i,j,k,2,2)*drho(i,j,k,2,2) + &
                drho(i,j,k,3,2)*drho(i,j,k,3,2))
           laprho(i,j,k,2) = &
                (rho(i+1,j,k,2) + rho(i-1,j,k,2) - 2.0d0*rho(i,j,k,2)) &
                /(1.0d0/nx)/(1.0d0/nx) &
                + (rho(i,j+1,k,2) + rho(i,j-1,k,2) - 2.0d0*rho(i,j,k,2)) &
                /(1.0d0/ny)/(1.0d0/ny) &
                + (rho(i,j,k+1,2) + rho(i,j,k-1,2) - 2.0d0*rho(i,j,k,2)) &
                /(1.0d0/nz)/(1.0d0/nz)

           drhot(1) = drho(i,j,k,1,1) + drho(i,j,k,1,2)
           drhot(2) = drho(i,j,k,2,1) + drho(i,j,k,2,2)
           drhot(3) = drho(i,j,k,3,1) + drho(i,j,k,3,2)
           adrhot(i,j,k) = sqrt(drhot(1)*drhot(1) + &
                drhot(2)*drhot(2) + drhot(3)*drhot(3))
        end do
     end do
  end do
  do k=3,nz-3
     do j=3,ny-3
        do i=3,nx-3
           dadrho(1) = (adrho(i+1,j,k,1) - adrho(i-1,j,k,1))/(2.0d0/nx)
           dadrho(2) = (adrho(i,j+1,k,1) - adrho(i,j-1,k,1))/(2.0d0/ny)
           dadrho(3) = (adrho(i,j,k+1,1) - adrho(i,j,k-1,1))/(2.0d0/nz)
           delgr(i,j,k,1) = drho(i,j,k,1,1)*dadrho(1) + &
                drho(i,j,k,2,1)*dadrho(2) + &
                drho(i,j,k,3,1)*dadrho(3)
           dadrho(1) = (adrho(i+1,j,k,2) - adrho(i-1,j,k,2))/(2.0d0/nx)
           dadrho(2) = (adrho(i,j+1,k,2) - adrho(i,j-1,k,2))/(2.0d0/ny)
           dadrho(3) = (adrho(i,j,k+1,2) - adrho(i,j,k-1,2))/(2.0d0/nz)
           delgr(i,j,k,2) = drho(i,j,k,1,2)*dadrho(1) + &
                drho(i,j,k,2,2)*dadrho(2) + &
                drho(i,j,k,3,2)*dadrho(3)

           dadrho(1) = (adrhot(i+1,j,k) - adrhot(i-1,j,k))/(2.0d0/nx)
           dadrho(2) = (adrhot(i,j+1,k) - adrhot(i,j-1,k))/(2.0d0/ny)
           dadrho(3) = (adrhot(i,j,k+1) - adrhot(i,j,k-1))/(2.0d0/nz)
           drhot(1) = drho(i,j,k,1,1) + drho(i,j,k,1,2)
           drhot(2) = drho(i,j,k,2,1) + drho(i,j,k,2,2)
           drhot(3) = drho(i,j,k,3,1) + drho(i,j,k,3,2)
           delgrt(i,j,k) = drhot(1)*dadrho(1) + &
                drhot(2)*dadrho(2) + drhot(3)*dadrho(3)
        end do
     end do
  end do

  nkfxa = 0
  do k=-(nz/2-1),nz/2-1
     z = dble(k)/nz
     do j=-(ny/2-1),ny/2-1
        y = dble(j)/ny
        do i=-(nx/2-1),nx/2-1
           x = dble(i)/nx
           if (sqrt(x*x + y*y + z*z) .lt. 1.0d0) then
              nkfxa = nkfxa + 1
              kf(1,nkfxa) = i
              kf(2,nkfxa) = j
              kf(3,nkfxa) = k
           end if
        end do
     end do
  end do
  bb = 0.0d0
  bb(1,1) = 2.0d0*pi
  bb(2,2) = 2.0d0*pi
  bb(3,3) = 2.0d0*pi
  va = 1.0d0
  call fft3_init(nx,ny,nz,nx,ny,nz,fs)
  tmprho = rho
  tmprhop = rhop
  call ggawb(2,nx,ny,nz,nx,ny,nz,nxyz,nkfxa,kf, &
     tmprhop,tmprho,va,bb,exa,exc,fs,1)
  tmprho2 = rho(:,:,:,1)+rho(:,:,:,2)
  tmprhop2 = rhop(:,:,:,1)+rhop(:,:,:,2)
  call ggawb(1,nx,ny,nz,nx,ny,nz,nxyz,nkfxa,kf, &
     tmprhop2,tmprho2,va,bb,exa,exc,fs,1)

  delta = 0.0d0
  do k=3,nz-3
     z = dble(k)/nz
     do j=3,ny-3
        y = dble(j)/ny
        do i=3,nx-3
           x = dble(i)/nx
           !write(6,'(1x,e10.4)') rhop(i,j,k,1),adrho(i,j,k,1),delgr(i,j,k,1),laprho(i,j,k,1), &
            !    rhop(i,j,k,2),adrho(i,j,k,2),delgr(i,j,k,2),laprho(i,j,k,2), &
            !    adrhot(i,j,k),delgrt(i,j,k)
           call easypbe( &
                rhop(i,j,k,1),adrho(i,j,k,1),delgr(i,j,k,1),laprho(i,j,k,1), &
                rhop(i,j,k,2),adrho(i,j,k,2),delgr(i,j,k,2),laprho(i,j,k,2), &
                adrhot(i,j,k),delgrt(i,j,k),1,1, &
                exlsd,vxuplsd,vxdnlsd,eclsd,vcuplsd,vcdnlsd, &
                expw91,vxuppw91,vxdnpw91,ecpw91,vcuppw91,vcdnpw91, &
                expbe,vxuppbe,vxdnpbe,ecpbe,vcuppbe,vcdnpbe)
           if (delta .lt. abs(tmprho(i,j,k,1)-vxuppbe-vcuppbe)) then
              imax(1) = i
              imax(2) = j
              imax(3) = k
              delta = abs(tmprho(i,j,k,1)-vxuppbe-vcuppbe)
           end if
           if (delta .lt. abs(tmprho(i,j,k,2)-vxdnpbe-vcdnpbe)) then
              imax(1) = i
              imax(2) = j
              imax(3) = k
              delta = abs(tmprho(i,j,k,2)-vxdnpbe-vcdnpbe)
           end if
           write(6,'(8(1x,e11.4))') x,y,z,tmprho2(i,j,k),tmprho(i,j,k,1), vxuppbe+vcuppbe, tmprho(i,j,k,2), vxdnpbe+vcdnpbe
        end do
     end do
  end do
  write(6,*) delta, imax
end program test

subroutine chkalloc(where,for,err)
  implicit none
  character(len=*) where, for
  integer err
  if (err.ne.0) then
     write(6,*)'allocation err: ',where,': ',for,': err = ',err
     stop
  end if
  return
end subroutine chkalloc
